from edison_dictionary_api import EdisonBaseAPI


class emotionsController(EdisonBaseAPI):
    """Emotions"""

    _controller_name = "emotionsController"

    def add(self, code, **kwargs):
        """

        Args:
            code: (string): code
            languageId: (string): languageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'code': {'name': 'code', 'required': True, 'in': 'query'}, 'languageId': {'name': 'languageId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/emotions/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, emotionId):
        """

        Args:
            emotionId: (string): emotionId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionId': {'name': 'emotionId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, emotionId):
        """

        Args:
            emotionId: (string): emotionId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'emotionId': {'name': 'emotionId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/emotions/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
