from edison_dictionary_api import EdisonBaseAPI


class sentimentsDocumentsController(EdisonBaseAPI):
    """Sentiments documents"""

    _controller_name = "sentimentsDocumentsController"

    def add(self, sentimentLanguageId, text, **kwargs):
        """

        Args:
            sentimentLanguageId: (string): sentimentLanguageId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-documents/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def addFile(self, files, sentimentLanguageId, **kwargs):
        """Supported file formats: https://tika.apache.org/1.13/formats.html

        Args:
            files: (array): files
            sentimentLanguageId: (type): sentimentLanguageId
            splitByLines: (type): splitByLines

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'files': {'name': 'files', 'required': True, 'in': 'formData'}, 'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'formData'}, 'splitByLines': {'name': 'splitByLines', 'required': False, 'in': 'formData'}}
        parameters_names_map = {}
        api = '/sentiments-documents/addFile'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, sentimentDocumentId, text, **kwargs):
        """

        Args:
            sentimentDocumentId: (string): sentimentDocumentId
            text: (type): text
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentDocumentId': {'name': 'sentimentDocumentId', 'required': True, 'in': 'query'}, 'text': {'name': 'text', 'required': True, 'in': 'body'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-documents/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, sentimentLanguageId, **kwargs):
        """

        Args:
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sentimentLanguageId: (string): sentimentLanguageId
            sortMode: (string): { "weight", "proximity", "doc2vec", "keywords", "entities" }
            sortOrderAscending: (boolean): true = ascending (default); false = descending

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}, 'sortMode': {'name': 'sortMode', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-documents/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, sentimentDocumentId):
        """

        Args:
            sentimentDocumentId: (string): sentimentDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentDocumentId': {'name': 'sentimentDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-documents/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, sentimentDocumentId):
        """

        Args:
            sentimentDocumentId: (string): sentimentDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentDocumentId': {'name': 'sentimentDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-documents/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
