from edison_dictionary_api import EdisonBaseAPI


class sentimentsLanguagesController(EdisonBaseAPI):
    """Sentiment languages"""

    _controller_name = "sentimentsLanguagesController"

    def add(self, languageId, sentimentId):
        """

        Args:
            languageId: (string): languageId
            sentimentId: (string): sentimentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}, 'sentimentId': {'name': 'sentimentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-languages/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, sentimentId):
        """

        Args:
            sentimentId: (string): sentimentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentId': {'name': 'sentimentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-languages/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, sentimentLanguageId):
        """

        Args:
            sentimentLanguageId: (string): sentimentLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-languages/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, sentimentLanguageId):
        """

        Args:
            sentimentLanguageId: (string): sentimentLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'sentimentLanguageId': {'name': 'sentimentLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/sentiments-languages/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
