from edison_dictionary_api import EdisonBaseAPI


class stopWordBanksController(EdisonBaseAPI):
    """Banks of the stop words."""

    _controller_name = "stopWordBanksController"

    def add(self, languageId):
        """

        Args:
            languageId: (string): languageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/stop-word-banks/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/stop-word-banks/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, bankId):
        """

        Args:
            bankId: (string): bankId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'bankId': {'name': 'bankId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/stop-word-banks/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, bankId):
        """

        Args:
            bankId: (string): bankId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'bankId': {'name': 'bankId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/stop-word-banks/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
