from edison_dictionary_api import EdisonBaseAPI


class testGroupsLanguagesController(EdisonBaseAPI):
    """Test groups languages"""

    _controller_name = "testGroupsLanguagesController"

    def add(self, languageId, testGroupId):
        """

        Args:
            languageId: (string): languageId
            testGroupId: (string): testGroupId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}, 'testGroupId': {'name': 'testGroupId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/test-groups-languages/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, testGroupId):
        """

        Args:
            testGroupId: (string): testGroupId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'testGroupId': {'name': 'testGroupId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/test-groups-languages/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, testGroupLanguageId):
        """

        Args:
            testGroupLanguageId: (string): testGroupLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'testGroupLanguageId': {'name': 'testGroupLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/test-groups-languages/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, testGroupLanguageId):
        """

        Args:
            testGroupLanguageId: (string): testGroupLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'testGroupLanguageId': {'name': 'testGroupLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/test-groups-languages/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def run(self, testGroupLanguageId, **kwargs):
        """

        Args:
            includeChanged: (boolean): includeChanged
            includeMissing: (boolean): includeMissing
            includeUnchanged: (boolean): includeUnchanged
            includeUnexpected: (boolean): includeUnexpected
            testGroupLanguageId: (string): testGroupLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'includeChanged': {'name': 'includeChanged', 'required': False, 'in': 'query'}, 'includeMissing': {'name': 'includeMissing', 'required': False, 'in': 'query'}, 'includeUnchanged': {'name': 'includeUnchanged', 'required': False, 'in': 'query'}, 'includeUnexpected': {'name': 'includeUnexpected', 'required': False, 'in': 'query'}, 'testGroupLanguageId': {'name': 'testGroupLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/test-groups-languages/run'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
