from edison_dictionary_api import EdisonBaseAPI


class themesController(EdisonBaseAPI):
    """Themes"""

    _controller_name = "themesController"

    def add(self, code, **kwargs):
        """

        Args:
            code: (string): code
            languageId: (string): languageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'code': {'name': 'code', 'required': True, 'in': 'query'}, 'languageId': {'name': 'languageId', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/themes/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, themeId):
        """

        Args:
            themeId: (string): themeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeId': {'name': 'themeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, themeId):
        """

        Args:
            themeId: (string): themeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeId': {'name': 'themeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
