from edison_dictionary_api import EdisonBaseAPI


class themesLanguagesController(EdisonBaseAPI):
    """Themes languages"""

    _controller_name = "themesLanguagesController"

    def add(self, languageId, themeId):
        """

        Args:
            languageId: (string): languageId
            themeId: (string): themeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}, 'themeId': {'name': 'themeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-languages/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, themeId):
        """

        Args:
            themeId: (string): themeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeId': {'name': 'themeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-languages/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, themeLanguageId):
        """

        Args:
            themeLanguageId: (string): themeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeLanguageId': {'name': 'themeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-languages/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, themeLanguageId):
        """

        Args:
            themeLanguageId: (string): themeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'themeLanguageId': {'name': 'themeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/themes-languages/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
