from edison_dictionary_api import EdisonBaseAPI


class topicTypesDocumentsController(EdisonBaseAPI):
    """Topic-types documents"""

    _controller_name = "topicTypesDocumentsController"

    def add(self, text, topicTypeLanguageId, **kwargs):
        """

        Args:
            text: (type): text
            topicTypeLanguageId: (string): topicTypeLanguageId
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'text': {'name': 'text', 'required': True, 'in': 'body'}, 'topicTypeLanguageId': {'name': 'topicTypeLanguageId', 'required': True, 'in': 'query'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-documents/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def addFile(self, files, topicTypeLanguageId, **kwargs):
        """Supported file formats: https://tika.apache.org/1.13/formats.html

        Args:
            files: (array): files
            splitByLines: (type): splitByLines
            topicTypeLanguageId: (type): topicTypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'files': {'name': 'files', 'required': True, 'in': 'formData'}, 'splitByLines': {'name': 'splitByLines', 'required': False, 'in': 'formData'}, 'topicTypeLanguageId': {'name': 'topicTypeLanguageId', 'required': True, 'in': 'formData'}}
        parameters_names_map = {}
        api = '/topic-types-documents/addFile'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def edit(self, text, topicTypeDocumentId, **kwargs):
        """

        Args:
            text: (type): text
            topicTypeDocumentId: (string): topicTypeDocumentId
            weight: (number): weight

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'text': {'name': 'text', 'required': True, 'in': 'body'}, 'topicTypeDocumentId': {'name': 'topicTypeDocumentId', 'required': True, 'in': 'query'}, 'weight': {'name': 'weight', 'required': False, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-documents/edit'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, topicTypeLanguageId, **kwargs):
        """

        Args:
            maxLength: (integer): maxLength
            maxNumber: (integer): maxNumber
            offset: (integer): offset
            sortMode: (string): { "weight", "proximity", "doc2vec", "keywords", "entities" }
            sortOrderAscending: (boolean): true = ascending (default); false = descending
            topicTypeLanguageId: (string): topicTypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'maxLength': {'name': 'maxLength', 'required': False, 'in': 'query'}, 'maxNumber': {'name': 'maxNumber', 'required': False, 'in': 'query'}, 'offset': {'name': 'offset', 'required': False, 'in': 'query'}, 'sortMode': {'name': 'sortMode', 'required': False, 'in': 'query'}, 'sortOrderAscending': {'name': 'sortOrderAscending', 'required': False, 'in': 'query'}, 'topicTypeLanguageId': {'name': 'topicTypeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-documents/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, topicTypeDocumentId):
        """

        Args:
            topicTypeDocumentId: (string): topicTypeDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicTypeDocumentId': {'name': 'topicTypeDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-documents/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, topicTypeDocumentId):
        """

        Args:
            topicTypeDocumentId: (string): topicTypeDocumentId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicTypeDocumentId': {'name': 'topicTypeDocumentId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-documents/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
