from edison_dictionary_api import EdisonBaseAPI


class topicTypesLanguagesController(EdisonBaseAPI):
    """Topic-types languages"""

    _controller_name = "topicTypesLanguagesController"

    def add(self, languageId, topicTypeId):
        """

        Args:
            languageId: (string): languageId
            topicTypeId: (string): topicTypeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'languageId': {'name': 'languageId', 'required': True, 'in': 'query'}, 'topicTypeId': {'name': 'topicTypeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-languages/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self, topicTypeId):
        """

        Args:
            topicTypeId: (string): topicTypeId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicTypeId': {'name': 'topicTypeId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-languages/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, topicTypeLanguageId):
        """

        Args:
            topicTypeLanguageId: (string): topicTypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicTypeLanguageId': {'name': 'topicTypeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-languages/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, topicTypeLanguageId):
        """

        Args:
            topicTypeLanguageId: (string): topicTypeLanguageId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicTypeLanguageId': {'name': 'topicTypeLanguageId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topic-types-languages/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
