from edison_dictionary_api import EdisonBaseAPI


class topicsController(EdisonBaseAPI):
    """Topics"""

    _controller_name = "topicsController"

    def add(self, code):
        """

        Args:
            code: (string): code

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'code': {'name': 'code', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topics/add'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def list(self):
        """"""

        all_api_parameters = {}
        parameters_names_map = {}
        api = '/topics/list'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def remove(self, topicId):
        """

        Args:
            topicId: (string): topicId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicId': {'name': 'topicId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topics/remove'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)

    def retrieve(self, topicId):
        """

        Args:
            topicId: (string): topicId

        Returns:
            application/json;charset=UTF-8
        """

        all_api_parameters = {'topicId': {'name': 'topicId', 'required': True, 'in': 'query'}}
        parameters_names_map = {}
        api = '/topics/retrieve'
        actions = ['post']
        params, data = self._format_params_for_api(locals(), all_api_parameters, parameters_names_map)
        return self._process_api(self._controller_name, api, actions, params, data)
